<?php
/*
 * Plugin Name: Evercookie
 * Plugin URI: http://php-dev.info/
 * Description: Evercookie is a plugin to track users with persistent cookies. If you have evil users on your Blog you can track their IP-Adress history on visiting your Blog. Evercookie set 13 types of Cookies to track the user. So if they delete the http-cookies you can identifier them too. More information on: http://en.wikipedia.org/wiki/Evercookie
 * Version: 1.0.3
 * Author: Ilya Beliaev
 * Author URI: http://php-dev.info/
 * License: GPLv2
 */
/*
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
*/
    if(!defined('ABSPATH')){
        die("Go away kiddie");
    };
    
    error_reporting(E_ALL ^ E_NOTICE ^ E_STRICT);
    define('WP_EVERCOOKIE_VERSION', '1.0.3');
    update_option('wp_evercookie_plugin_version', WP_EVERCOOKIE_VERSION);
    
    //Init von weiteren Scripten
    require_once dirname( __FILE__ ) . '/upgrade.php';
    require_once dirname( __FILE__ ) . '/install.php';
    require_once dirname( __FILE__ ) . '/uninstall.php';
    //init ende
    
    //Installation des Plugins
    register_activation_hook(__FILE__, 'wp_evercookie_install');
    //Installation ende
    
    //Deinstallation des Plugins
    register_deactivation_hook(__FILE__, 'wp_evercookie_uninstall');
    //Deinstallation ende
    
   
    //evercontrol.js den Pfad der URL mitteilen für die Ausführung der Posts
    function my_enqueue($hook) {
        wp_enqueue_script('swf-script', plugins_url( '/js/swfobject-2.2.min.js', __FILE__ ));
        wp_enqueue_script('ever-script', plugins_url( '/js/evercookie.js', __FILE__ ));
        wp_enqueue_script('ajax-script', plugins_url( '/js/evercontrol.js', __FILE__ ), array('jquery'));
        // in javascript, object properties are accessed as ajax_object.ajax_url, ajax_object.we_value
        wp_localize_script( 'ajax-script', 
                            'ajax_object',
                            array( 
                                'ajax_url' => admin_url('admin-ajax.php'), 
                            ) 
        );
    }
    
    add_action('wp_enqueue_scripts', 'my_enqueue');
    //mitteilen ende
    
    //Einfügen einer neuen IP-Adresse zu einem Evercookie
    function insert_iplist($everid, $ipaddr){
        global $table_prefix, $wpdb;
        $result = $wpdb->query( $wpdb->prepare( 
                            "INSERT INTO {$table_prefix}evercookie_iplist ( everid, ipaddress, tstamp )
                             VALUES ( %d, %s, %d )
                            ", 
                            $everid, 
                            $ipaddr, 
                            time() 
                        )
        );
                  
        return $result;
    }
    //Einfügen ende
    
    //Fügt ein neues Evercookie ein
    function insert_evercookie($cookie){
        global $table_prefix, $wpdb;
        $result = $wpdb->query( $wpdb->prepare( 
                            "INSERT INTO {$table_prefix}evercookie (evervalue)
                             VALUES (%s)
                            ", 
                            $cookie
                        )
        );
        
        if($result){
            $return = $wpdb->insert_id;
        }else{
            $return = false;
        }
        return $return;
    }
    //einfügen ende
    
    //Überprüfen ob eine IP-Adresse bereits in der Datenbank hinterlegt wurde zu diesem Cookie
    function get_everip_match_iplist($cookie, $ipaddr){
        global $table_prefix, $wpdb;
        
        $avail = (boolean)$wpdb->get_var( 
                    $wpdb->prepare( 
                        "
                        SELECT count(*) as avail
                        FROM {$table_prefix}evercookie_iplist
                        NATURAL LEFT JOIN {$table_prefix}evercookie
                        WHERE evervalue = %s
                        AND ipaddress = %s
                        ", 
                        $cookie,
                        $ipaddr
                    )
        );
                        
        return $avail;
    }
    //Überprüfen ende
    /*
     * Setzt den Timestamp einer IP-Adresse hoch sofern der user 
     * mit dem entsprechenden cookie wieder mit der selben IP-Adresse aktiv ist.
     */
    function set_everip_tstamp($everid, $ipaddr){
        global $table_prefix, $wpdb;
        
        $status = $wpdb->update( 
                            "{$table_prefix}evercookie_iplist", 
                            array( 
                                'tstamp' => time(),
                            ), 
                            array( 'everid' => $everid, "ipaddress" => $ipaddr )
        );
        return $status;
    }
    //tstamp ende
    
    /**
     * Ermitteln der IP-Adresse
     * @return type
     */
    function getIP() {
        if (getenv('HTTP_CLIENT_IP')) {
            $ip = getenv('HTTP_CLIENT_IP');
        } elseif (getenv('HTTP_X_FORWARDED_FOR')) {
            $ip = getenv('HTTP_X_FORWARDED_FOR');
        } elseif (getenv('HTTP_X_FORWARDED')) {
            $ip = getenv('HTTP_X_FORWARDED');
        } elseif (getenv('HTTP_FORWARDED_FOR')) {
            $ip = getenv('HTTP_FORWARDED_FOR');
        } elseif (getenv('HTTP_FORWARDED')) {
            $ip = getenv('HTTP_FORWARDED');
        } else {
            $ip = $_SERVER['REMOTE_ADDR'];
        }
        return $ip;
    }
    
    //Verarbeitung des Ajax-Requests
    function evercookie_callback(){
        global $table_prefix, $wpdb;
        
        $ipaddr = getIP();
        $cookie = $_POST["evervalue"];
        
        if(!empty($cookie)){
            $everid = (int)$wpdb->get_var( 
                            $wpdb->prepare( 
                                "
                                SELECT everid
                                FROM {$table_prefix}evercookie
                                WHERE evervalue = %s
                                ", 
                                $cookie
                            ) 
                );
           if($everid != 0){
               if(get_everip_match_iplist($cookie, $ipaddr) === false){
                   insert_iplist($everid, $ipaddr);
               }else{
                   set_everip_tstamp($everid, $ipaddr);
               }
                echo "OK";
           }else{
               $cookie = "Guest".time().rand(100, 200);
               $everid = insert_evercookie($cookie);
               
               if($everid !== false){
                   insert_iplist($everid, $ipaddr);
               }
               echo $cookie;
           }                  
        }else{
            $cookie = "Guest".time().rand(100, 200);
            $everid = insert_evercookie($cookie);
            if($everid !== false){
                insert_iplist($everid, $ipaddr);
            }
            echo $cookie;
        }
        
        die();
    }
    
    add_action('wp_ajax_evercookie', 'evercookie_callback');
    add_action('wp_ajax_nopriv_evercookie', 'evercookie_callback');
    //Ajax Ende
    
    
    /************************************************************
     * Admin Interface
     ************************************************************/
    
    function wp_evercookie_menu() {
        if (function_exists('add_options_page')){
            add_menu_page("Evercookie", "Evercookie", 'manage_options', __FILE__, 'wp_evercookie_stats', plugin_dir_url( __FILE__ ).'/images/icon.png');
            /*
            add_submenu_page(__FILE__, __('View Stats', 'wp_evercookie'), __('View Stats', 'wp_evercookie'), 'manage_options', __FILE__, 'wp_statistics_log');
            add_submenu_page(__FILE__, __('Settings', 'wp_evercookie'), __('Settings', 'wp_evercookie'), 'manage_options', 'wp-statistics/settings', 'wp_statistics_settings');
             * 
             */
        }
    }
    
    /**
     * Evercookie Stats Admin Table
     */
    function wp_evercookie_stats(){
        if (!current_user_can('manage_options')) {
            wp_die(__('You do not have sufficient permissions to access this page.'));
        }
        
        wp_enqueue_style('evercookie', plugin_dir_url(__FILE__) . 'css/style.css', true, '1.0');
        wp_enqueue_script('ajax-script', plugins_url( '/js/highcharts.js', __FILE__ ), array('jquery'));
        
        
        $delid = (int)$_GET["everid"];
        
        //delete cookie when administrator clicking on the delete button
        if(!empty($delid) && $delid > 0){
            deleteEverCookie($delid);
        }
        $visitors = getVisitors();
        $monthvisits = getUniqueMonthVisitors();
        $visits = array();
        foreach($monthvisits as $visit){
            $visits[$visit["date"]] = $visit["visitorcount"];
        }
        
        require_once(dirname( __FILE__ )."/templates/overview.php");
    }
    
    /**
     * Cookie aus der Datenbank löschen
     * @global String $table_prefix WP Table Prefix
     * @global object $wpdb Wordpress Query Object
     * @param int $everid Evercookie-ID
     * @return type
     */
    function deleteEverCookie($everid){
        global $table_prefix, $wpdb;
        $status = $wpdb->query( $wpdb->prepare( 
                            "DELETE FROM {$table_prefix}evercookie
                             WHERE everid = %d
                            ", 
                            $everid
                        )
        );
        return $status;      
    }
    
    /**
     * Letzten Besuchszeitpunkt ermitteln
     * @global String $table_prefix WP Table Prefix
     * @global object $wpdb Wordpress Query Object
     * @param String $cookie Cookie Value
     * @return mixed Date or false
     */
    function getLastVisit($cookie){
        global $table_prefix, $wpdb;
        
        $lastvisit = $wpdb->get_var( 
                            $wpdb->prepare("
                                SELECT FROM_UNIXTIME(tstamp) as lastvisit
                                FROM {$table_prefix}evercookie
                                NATURAL JOIN {$table_prefix}evercookie_iplist
                                WHERE evervalue = %s
                                ", 
                                $cookie
                            ) 
        );
                                
        if(!empty($lastvisit)){
            $result = $lastvisit;
        }else{
            $result = false;
        }
        return $result;
    }
    
    /**
     * Holt alle Besuche der Webseite eines individuellen einzigartigen Besuchers für einen Monat
     * @global String $table_prefix Table Prefix
     * @global object $wpdb Datenbankobjekt
     * @param type $date 'JAHR-MONAT' als date (Optional)
     * @return array 
     */
    function getUniqueMonthVisitors($date = NULL){
       global $table_prefix, $wpdb;
       If($date === NULL){
           $date = date("Y-m")."%";
       } 
       
       $query = "SELECT COUNT(*) as visitorcount, DAYOFMONTH(FROM_UNIXTIME(tstamp)) as `date`
                FROM (
                        SELECT *
                        FROM `{$table_prefix}evercookie_iplist`
                        GROUP BY everid
                ) as filtered
                WHERE FROM_UNIXTIME(tstamp) LIKE %s
                GROUP BY date;";
       return $wpdb->get_results($wpdb->prepare($query,$date), ARRAY_A);
    }
    
    /**
     * Alle Besucher als multidimensionales Array holen
     * @global String $table_prefix WP Table Prefix
     * @global object $wpdb Wordpress Query Object
     * @return array Visitors
     */
    function getVisitors(){
        global $table_prefix, $wpdb;
        
        $query = "SELECT everid, evervalue, GROUP_CONCAT(ipaddress SEPARATOR '\n') as ipaddrs, FROM_UNIXTIME(MAX(tstamp)) as lastvisit
                  FROM {$table_prefix}evercookie
                  NATURAL JOIN {$table_prefix}evercookie_iplist
                  GROUP BY everid
                  ORDER BY MAX(tstamp) DESC;";
                  
        return $wpdb->get_results($query, ARRAY_A);
    }
    
    add_action('admin_menu', 'wp_evercookie_menu');
?>