<?php
    if(defined('WP_EVERCOOKIE_VERSION') && is_admin()){
        function wp_evercookie_install(){
            global $wp_ervercookie_db_version, $table_prefix;
            
            //Erstellt die Tabelle für die individuellen Cookies
            $create_evercookie_table = "CREATE TABLE IF NOT EXISTS `{$table_prefix}evercookie` (
                `everid` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'cookie id',
                `evervalue` varchar(150) NOT NULL COMMENT 'Unique Cookie value',
                PRIMARY KEY (`everid`),
                UNIQUE KEY `evervalue` (`evervalue`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
            
            /*
             * Erstellt die Tabelle für die zuordnung von den jeweiligen IP-Adressen zu den einzelnen evercookies
             * aus der Tabelle PREFIX_evercookie (1:n Beziehung)
             */
            $create_evercookie_iplist_table = "CREATE TABLE IF NOT EXISTS `{$table_prefix}evercookie_iplist` (
                `ipid` int(10) unsigned NOT NULL AUTO_INCREMENT,
                `everid` int(10) unsigned NOT NULL,
                `ipaddress` varchar(15) NOT NULL,
                `tstamp` int(11) unsigned NOT NULL,
                PRIMARY KEY (`ipid`),
                KEY `everid` (`everid`)
            ) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;";
            
            /*
             * Referentielle Integrität anlegen für die Tabellen
             * PREFIX_evercookie und PREFIX_evercookie_iplist
             * PREFIX_evercookie 1 <==========> n PREFIX_evercookie_iplist
             * Auf UPDATE und DELETE kaskadieren
             */
            $create_evercookie_referential_integrity = "ALTER TABLE `{$table_prefix}evercookie_iplist`
            ADD CONSTRAINT `everid` FOREIGN KEY (`everid`) REFERENCES `{$table_prefix}evercookie` (`everid`) ON DELETE CASCADE ON UPDATE CASCADE;";
            
            require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
            
            dbDelta($create_evercookie_table);
            dbDelta($create_evercookie_iplist_table);
            dbDelta($create_evercookie_referential_integrity);
            
            
            add_option('wp_ervercookie_db_version', WP_EVERCOOKIE_VERSION);
        } 
    }
?>
